//
//  ContactsModel.swift
//  AgendaAssistent
//
//  Created by André Hartman on 15/12/2023.
//  Copyright © 2023 André Hartman. All rights reserved.
//
import Contacts
import MapKit

/*
 class ContactsModel {
 public func enrichPatients(patients: [PatientInfo]) {
 let contacts = getContacts()
 var localPatients = [PatientInfo.Patient]()
 for patient in patients {
 let localPatient = PatientInfo.Patient(
 id: patient.id,
 patientName: patient.patientName,
 patientLatitude: patient.patientLatitude,
 patientLongitude: patient.patientLongitude
 )
 localPatients.append(localPatient)
 }
 // update from Contacts
 let (localContactPatients, localGeoPatients) = updatePatientsFromContacts(patients: localPatients, contacts: contacts)
 DBModel().updateFromGeo(patients: localContactPatients)

 // update from geocoding
 updateGeo(patients: localGeoPatients, contacts: contacts)
 }

 func updateGeo(patients: [PatientInfo.Patient], contacts: [CNContact]) {
 // update from geocoding
 Task {
 let temp = await updatePatientsFromGeocoder(patients: patients, contacts: contacts)
 DBModel().updateFromGeo(patients: temp)
 }
 }

 func updatePatientsFromContacts(patients: [PatientInfo.Patient], contacts: [CNContact]) -> ([PatientInfo.Patient], [PatientInfo.Patient]) {
 var localPatientsFound = [PatientInfo.Patient]()
 var localPatientsNotFound = [PatientInfo.Patient]()
 var counter = 0
 for patient in patients {
 var found = false
 let contact = contacts.first(where: {
 patient.patientName.localizedStandardContains($0.givenName) &&
 patient.patientName.localizedStandardContains($0.familyName)
 })
 if let geoContact = contact {
 var coordinates = [String]()
 if geoContact.previousFamilyName.contains(":") {
 found = true
 counter += 1
 coordinates = geoContact.previousFamilyName.components(separatedBy: ":")
 localPatientsFound.append(PatientInfo.Patient(
 id: patient.id,
 patientName: patient.patientName,
 patientLatitude: Double(coordinates[0]),
 patientLongitude: Double(coordinates[1])
 ))
 }
 }
 if !found {
 localPatientsNotFound.append(PatientInfo.Patient(
 id: patient.id,
 patientName: patient.patientName
 ))
 }
 }
 print("Contacts geo found for: \(counter) patients")
 return (localPatientsFound, localPatientsNotFound)
 }

 func updatePatientsFromGeocoder(patients: [PatientInfo.Patient], contacts: [CNContact]) async -> [PatientInfo.Patient] {
 var localPatients = [PatientInfo.Patient]()
 var counter = 0

 var patients = patients
 patients.shuffle()
 let min = min(patients.count, 49) - 1
 for patient in Array(patients[...min]) {
 let contact = contacts.first(where: {
 patient.patientName.localizedStandardContains($0.givenName) &&
 patient.patientName.localizedStandardContains($0.familyName)

 })
 if let geoContact = contact {
 var location: String
 if let postalAddress = (geoContact.postalAddresses.first) {
 location = await getGeocode(postalAddress: postalAddress.value)
 if location.contains(":") {
 let coordinates = location.components(separatedBy: ":")
 counter += 1
 localPatients.append(
 PatientInfo.Patient(
 id: patient.id,
 patientName: patient.patientName,
 patientLatitude: Double(coordinates[0]),
 patientLongitude: Double(coordinates[1])
 )
 )
 }
 }
 }
 }
 if counter > 0 {
 print("Geocoding found for \(counter) patients")
 }
 return localPatients
 }

 func getGeocode(postalAddress: CNPostalAddress) async -> String {
 var coordinates = ""
 do {
 let placemarks = try await CLGeocoder().geocodePostalAddress(postalAddress)
 var location: CLLocation?
 location = placemarks.first?.location
 if let location = location {
 coordinates = "\(location.coordinate.latitude):\(location.coordinate.longitude)"
 }
 } catch {
 if debugPrint { print("CLGeocoder fout (adres niet gevonden): \(error), \(postalAddress)") }
 }
 return coordinates
 }

 public func getContacts() -> [CNContact] {
 let authStatus = CNContactStore.authorizationStatus(for: .contacts)
 switch authStatus {
 case .restricted:
 print("User cannot grant permission, e.g. parental controls in force.")
 exit(1)
 case .denied:
 print("User has explicitly denied permission.")
 print("They have to grant it via Preferences app if they change their mind.")
 exit(1)
 case .notDetermined:
 print("You need to request authorization via the API now.")
 case .authorized:
 _ = 1
 //print("You are authorized to Contacts.")
 default:
 print("Unknown issue in switch")
 }

 let store = CNContactStore()
 if authStatus == .notDetermined {
 store.requestAccess(for: CNEntityType.contacts) { success, error in
 if !success {
 print("Not authorized to access contacts. Error = \(String(describing: error))")
 exit(1)
 }
 }
 }
 return retrieveContacts(from: store)
 }

 private func retrieveContacts(from contactStore: CNContactStore) -> [CNContact] {
 var contacts = [CNContact]()
 let keysToFetch = [
 CNContactGivenNameKey,
 CNContactFamilyNameKey,
 CNContactPreviousFamilyNameKey,
 CNContactPostalAddressesKey,
 ] as [CNKeyDescriptor]
 let request = CNContactFetchRequest(keysToFetch: keysToFetch)
 request.sortOrder = CNContactSortOrder.userDefault

 do {
 try contactStore.enumerateContacts(with: request) {
 contact, _ in
 contacts.append(contact)
 }
 } catch {
 print("Error fetching results for Contacts container")
 }
 return contacts
 }
 }
 */
