//
//  WrtieCSV.swift
//  AgendaAssistent
//
//  Created by André Hartman on 13/02/2022.
//  Copyright © 2022 André Hartman. All rights reserved.
//
import SwiftUI

struct CommandsView: View {
    @Environment(MainModel.self) private var model
    var title: String
    var body: some View {
        VStack {
            HStack {
                Spacer()
                Text("Van: ")
                Text(model.periodDates.start, style: .date)
                Spacer()
                Text("tot: ")
                Text(model.periodDates.end, style: .date)
                Spacer()
            }
            .environment(\.locale, Locale(identifier: "nl"))
            Divider()
            HStack {
                Spacer()
                Button(action: { DBModel().getPatientTimelineTest() }) {
                    Text("Get Timeline")
                        .padding()
                        .background(kleur)
                        .foregroundColor(.white)
                        .clipShape(Capsule())
                }
                Spacer()
            }
            .padding()
            .buttonStyle(.borderless)
        }
        .navigationBarTitle(title, displayMode: .inline)
        .statusBar(hidden: true)
        .frame(maxWidth: 600)
        .border(.gray)
    }
}
